/**
 * This class is used to create an Display object.
 * Input is one HTMLElement that can then be hidden or shown depending on
 * its CSS classes.
 */
class Display {
  constructor(element) {
    // with this function initalized modals can also be handeld
    this.element = (() => {if (element instanceof HTMLElement) {
                            return element;
                          } else {
                            element = element['$el'][0];
                            return element;
                          }
    })();
    this.errorContainer = element.querySelector('.error-container');
    this.showOnError = element.querySelectorAll('.show-on-error');
    this.showOnSuccess = element.querySelectorAll('.show-on-success');
    this.showWhileWaiting = element.querySelectorAll('.show-while-waiting');
    this.hideOnComplete = element.querySelectorAll('.hide-on-complete')
  }

  // Changes the visibility of its own
  setVisibilityByStatus(status) {
    switch (status) {
      case 'error':
        for (let element of this.showOnError) {
          element.classList.remove('hide');
        }
        for (let element of this.showOnSuccess) {
          element.classList.add('hide');
        }
        for (let element of this.showWhileWaiting) {
          element.classList.add('hide');
        }
        break;
      case 'success':
        for (let element of this.showOnError) {
          element.classList.add('hide');

        }
        for (let element of this.showOnSuccess) {
          element.classList.remove('hide');
        }
        for (let element of this.showWhileWaiting) {
          element.classList.add('hide');
        }
        break;
      case 'waiting':
        for (let element of this.showOnError) {
          element.classList.add('hide');
        }
        for (let element of this.showOnSuccess) {
          element.classList.add('hide');
        }
        for (let element of this.showWhileWaiting) {
          element.classList.remove('hide');
        }
        break;
      default:
        // Hide all
        for (let element of this.showOnError) {
          element.classList.add('hide');
        }
        for (let element of this.showOnSuccess) {
          element.classList.add('hide');
        }
        for (let element of this.showWhileWaiting) {
          element.classList.add('hide');
        }
    }
  }
}